<?php
/**
 * Clase FN para CrCategoriaPrestamologFN
 *
 * @package    
 * @subpackage CrCategoriaPrestamologFN
 * @author     Willy
 * @version    SVN:: CrCategoriaPrestamologFN.class.php,v 1.1 2017-09-02 12:06:48 william.taype Exp $
 */
class CrCategoriaPrestamologFN extends BaseCrCategoriaPrestamologFN
{
	
	public function selectCronogramaCuotas($idPrestamo)
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();
      

      $con = Conexion::getConexion();
      $sql = "
      			SELECT  *
				FROM cr_cuota cuo
				WHERE 	1
						and idprestamo='".$idPrestamo."'"		
				
      		;
      
     
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[$o_valor->fecha."|".$o_valor->idprestamo] = $o_valor;
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectCategoriaLog($idPrestamo)
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();
      

      $con = Conexion::getConexion();
      $sql = "
      			SELECT  *
				FROM cr_categoria_prestamolog 
				WHERE 	1
						and idprestamo='".$idPrestamo."'"		
				
      		;
      
      
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[$o_valor->fecha."|".$o_valor->idprestamo] = $o_valor;
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }
  public function selectCategorias()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();
      

      $con = Conexion::getConexion();
      $sql = "
      			SELECT  *
				FROM cr_categoria_prestamo
				WHERE 	1
						"		
				
      		;
      
      
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $o_valor;
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }
	
	public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();
      $group = "GROUP BY suc.idsucursal,mer.idmercado,col.idcolaborador,idCategoria";

      $con = Conexion::getConexion();
      $sql = "
      			SELECT  suc.idsucursal,suc.descripcion as nombresucursal,mer.idmercado,mer.descripcion as nombremercado,col.idcolaborador,concat(col.ApellidoPaterno,' ', col.ApellidoMaterno,', ',col.Nombres) as nombrecolaborador ,prelog.idCategoria, prelog.nombrecategoria, count(pre.idprestamo) as cantidadprestamos
				FROM cr_categoria_prestamolog prelog
				LEFT JOIN cr_prestamo pre ON pre.idprestamo = prelog.idprestamo
				LEFT JOIN cr_cliente cli ON cli.idcliente = pre.idcliente
				LEFT JOIN cr_mercado mer ON mer.idmercado = cli.idmercado
				LEFT JOIN cr_sucursal_mercado sucmer ON sucmer.idmercado = mer.idmercado
				LEFT JOIN cr_sucursal suc ON suc.idsucursal = sucmer.idsucursal
				LEFT JOIN cr_mercado_representante merrep ON merrep.idmercado = mer.idmercado
				LEFT JOIN cr_colaborador col ON col.idcolaborador = merrep.idcolaborador
				WHERE 	1
						".$where." ".$group." ".$orden."  LIMIT ".$limitInf.",".$tamPag		
				
      		;
      
      //echo $sql;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
       
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      //echo $oLink." **<br>** ".$result;
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
         
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }
  
public function selectDet()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();
      

      $con = Conexion::getConexion();
      $sql = "
      			SELECT  prelog.idprestamo,prelog.fecha,suc.idsucursal,suc.descripcion as nombresucursal,mer.idmercado,mer.descripcion as nombremercado,col.idcolaborador,concat(col.ApellidoPaterno,' ', col.ApellidoMaterno,', ',col.Nombres) as nombrecolaborador ,prelog.idCategoria, prelog.nombrecategoria
				FROM cr_categoria_prestamolog prelog
				LEFT JOIN cr_prestamo pre ON pre.idprestamo = prelog.idprestamo
				LEFT JOIN cr_cliente cli ON cli.idcliente = pre.idcliente
				LEFT JOIN cr_mercado mer ON mer.idmercado = cli.idmercado
				LEFT JOIN cr_sucursal_mercado sucmer ON sucmer.idmercado = mer.idmercado
				LEFT JOIN cr_sucursal suc ON suc.idsucursal = sucmer.idsucursal
				LEFT JOIN cr_mercado_representante merrep ON merrep.idmercado = mer.idmercado
				LEFT JOIN cr_colaborador col ON col.idcolaborador = merrep.idcolaborador
				WHERE 	1
						".$where." ".$group." ".$orden."  LIMIT ".$limitInf.",".$tamPag		
				
      		;
      
       //echo $sql;
      //exit;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();
      
      $group = "GROUP BY suc.idsucursal,mer.idmercado,col.idcolaborador,idCategoria";

      $con = Conexion::getConexion();
      $sql = "SELECT suc.idsucursal,mer.idmercado,col.idcolaborador,prelog.idCategoria, prelog.nombrecategoria
				FROM cr_categoria_prestamolog prelog
				LEFT JOIN cr_prestamo pre ON pre.idprestamo = prelog.idprestamo
				LEFT JOIN cr_cliente cli ON cli.idcliente = pre.idcliente
				LEFT JOIN cr_mercado mer ON mer.idmercado = cli.idmercado
				LEFT JOIN cr_sucursal_mercado sucmer ON sucmer.idmercado = mer.idmercado
				LEFT JOIN cr_sucursal suc ON suc.idsucursal = sucmer.idsucursal
				LEFT JOIN cr_mercado_representante merrep ON merrep.idmercado = mer.idmercado
				LEFT JOIN cr_colaborador col ON col.idcolaborador = merrep.idcolaborador
				WHERE 1 ".$where." ".$group;
      //echo $sql;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }
  
   public function selectNumRowsDet()
  {
    try
    {
      $where = $this->buildConsult();
      
      $group = "GROUP BY suc.idsucursal,mer.idmercado,col.idcolaborador,idCategoria";

      $con = Conexion::getConexion();
      $sql = "SELECT suc.idsucursal,mer.idmercado,col.idcolaborador,prelog.idCategoria, prelog.nombrecategoria, count(pre.idprestamo)
				FROM cr_categoria_prestamolog prelog
				LEFT JOIN cr_prestamo pre ON pre.idprestamo = prelog.idprestamo
				LEFT JOIN cr_cliente cli ON cli.idcliente = pre.idcliente
				LEFT JOIN cr_mercado mer ON mer.idmercado = cli.idmercado
				LEFT JOIN cr_sucursal_mercado sucmer ON sucmer.idmercado = mer.idmercado
				LEFT JOIN cr_sucursal suc ON suc.idsucursal = sucmer.idsucursal
				LEFT JOIN cr_mercado_representante merrep ON merrep.idmercado = mer.idmercado
				LEFT JOIN cr_colaborador col ON col.idcolaborador = merrep.idcolaborador
				WHERE 1 ".$where." ".$group;
      //echo $sql;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }


  public function buildConsult()
  {
    try
    {
         
      
	  if($this->getIdSucursal()){$where .= " AND suc.idSucursal = '".$this->getIdSucursal()."'";}	
	  if($this->getIdMercado()){$where .= " AND mer.idMercado = '".$this->getIdMercado()."'";}	
      if($this->getIdColaborador()){ $where .= " AND col.idColaborador = '".$this->getIdColaborador()."'"; }
      if($this->getEstadoPrestamo()){ $where .= " and pre.estado = '".$this->getEstadoPrestamo()."'"; }
      if($this->getIdprestamo()){ $where .= " AND idprestamo = '".$this->getIdprestamo()."'"; }
      $where .= " AND fecha = '".$this->getFecha()."'"; 
      if($this->getNombrecategoria()){ $where .= " AND nombrecategoria = '".$this->getNombrecategoria()."'"; }
      if($this->getIdcategoria()){ $where .= " AND prelog.idcategoria = '".$this->getIdcategoria()."'"; }
      if($this->getPeso()){ $where .= " AND peso = '".$this->getPeso()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idprestamo, fecha, nombrecategoria, idcategoria, peso FROM cr_categoria_prestamolog WHERE 1 AND idprestamo='".$this->getIdprestamo()."' AND fecha='".$this->getFecha()."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseCrCategoriaPrestamologFN = new BaseCrCategoriaPrestamologFN();
    $o_BaseCrCategoriaPrestamologFN->setIdprestamo($o_propel->idprestamo);
    $o_BaseCrCategoriaPrestamologFN->setIdSucursal($o_propel->idsucursal);
    $o_BaseCrCategoriaPrestamologFN->setNombreSucursal($o_propel->nombresucursal);
    $o_BaseCrCategoriaPrestamologFN->setIdMercado($o_propel->idmercado);
    $o_BaseCrCategoriaPrestamologFN->setNombreMercado($o_propel->nombremercado);
    $o_BaseCrCategoriaPrestamologFN->setIdColaborador($o_propel->idcolaborador);
    $o_BaseCrCategoriaPrestamologFN->setNombreColaborador($o_propel->nombrecolaborador);
    $o_BaseCrCategoriaPrestamologFN->setFecha($o_propel->fecha);
    
    
    
    $o_BaseCrCategoriaPrestamologFN->setIdcategoria($o_propel->idCategoria);
    $o_BaseCrCategoriaPrestamologFN->setNombrecategoria($o_propel->nombrecategoria);
    $o_BaseCrCategoriaPrestamologFN->setPeso($o_propel->peso);
    $o_BaseCrCategoriaPrestamologFN->setCantidadPrestamos($o_propel->cantidadprestamos);
    return $o_BaseCrCategoriaPrestamologFN;
  }
	
}